﻿Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For i As Integer = 0 To 30
            Power_Of_2(i) = 2 ^ i
        Next i
        Power_Of_2(31) = -2147483648.0#
        FillTLook()
        Initialize_CPU()
        DirectSound_Initialize()
        pAPU_Initialize()
        Show()
    End Sub
    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        KeyCodes(e.KeyCode) = &H41
    End Sub
    Private Sub Form1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
        KeyCodes(e.KeyCode) = &H40
    End Sub
    Private Sub TmrFPS_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TmrFPS.Tick
        Static P As Long
        Static PTime As Double
        Dim CTime As Double

        CTime = Timer
        Label1.Text = Format((Frames - P) / (CTime - PTime), "0.0") & " fps"
        PTime = CTime
        P = Frames
    End Sub
    Private Sub XToolStripMenuitem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles XToolStripMenuItem.Click
        Zoom = 1
        Window_Setup()
    End Sub
    Private Sub XToolStripMenuitem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles XToolStripMenuItem1.Click
        Zoom = 2
        Window_Setup()
    End Sub
    Private Sub Window_Setup()
        With NesScreen
            .Width = 256 * Zoom
            .Height = 240 * Zoom
        End With
        With Me
            .Width = NesScreen.Width + 6
            .Height = NesScreen.Height + 28 + 24
            .Left = (Screen.PrimaryScreen.Bounds.Width / 2) - (.Width / 2)
            .Top = (Screen.PrimaryScreen.Bounds.Height / 2) - (.Height / 2)
        End With
    End Sub
    Private Sub NNToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NNToolStripMenuItem.Click
        InterpolMode = 5
    End Sub
    Private Sub LowToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LowToolStripMenuItem.Click
        InterpolMode = 1
    End Sub
    Private Sub HighToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HighToolStripMenuItem.Click
        InterpolMode = 2
    End Sub
    Private Sub AbrirROMToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AbrirROMToolStripMenuItem.Click
        AbreRom.ShowDialog()
        If AbreRom.FileName <> Nothing Then
            LoadROM(AbreRom.FileName)
        End If
    End Sub
    Private Sub FecharROMToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FecharROMToolStripMenuItem.Click
        DestroyNes()
        NesScreen.Image = Nothing
    End Sub
End Class
